(declare (unit cdk))

#>
#define HAVE_GETBEGX 1
#define HAVE_GETBEGY 1
#define HAVE_GETMAXX 1
#define HAVE_GETMAXY 1

#include <curses.h>
#include <cdk.h>
<#

#>?

typedef struct _win_st WINDOW;
typedef struct SScreen CDKSCREEN;
typedef struct CDK_PARAMS CDK_PARAMS;
typedef unsigned long chtype;
typedef int boolean;
typedef int EDisplayType;

___safe WINDOW *initscr(void);
___safe CDKSCREEN *initCDKScreen (WINDOW *cursesWindow);
___safe void initCDKColor (void) ;

___safe void refreshCDKScreen(
               CDKSCREEN *screen);

// ___safe CDKITEMLIST *newCDKItemlist (
//                CDKSCREEN *cdkscreen,
//                int xpos,
//                int ypos,
//                char *title,
//                char *label,
//                char **itemList,
//                int itemCount,
//                int defaultItem,
//                int box,
//                int shadow);
// 
// typedef struct SItemList CDKITEMLIST;
// 
// ___safe int activateCDKItemlist (
//                CDKITEMLIST *itemlist,
//                chtype *actions);
// 
// ___safe CDKALPHALIST *newCDKAlphalist (
//                CDKSCREEN *cdkscreen,
//                int xpos,
//                int ypos,
//                int height,
//                int width,
//                char * title,
//                char * label,
//                char ** list,
//                int listSize,
//                chtype fillerCharacter,
//                chtype highlight,
//                boolean box,
//                boolean shadow);
// 
// ___safe char *activateCDKAlphalist (
//                CDKALPHALIST *alphalist,
//                chtype *actions);
// 
// ___safe void destroyCDKAlphalist (
//                CDKALPHALIST *alphalist);

#define  CENTER          9002

___safe int CDKparamValue (
               CDK_PARAMS * params,
               int option,
               int missing);

___safe CDKSELECTION *newCDKSelection (
               CDKSCREEN *cdkscreen,
               int xpos,
               int ypos,
               int spos,
               int height,
               int width,
               char *title,
               char **selectionList,
               int selectionListLength,
               char **choiceList,
               int choiceListLength,
               chtype highlight,
               boolean box,
               boolean shadow);

___safe int activateCDKSelection (
               CDKSELECTION *selection,
               chtype *actions);

___safe void destroyCDKSelection (
               CDKSELECTION *selection);

___safe void eraseCDKSelection (
				CDKSELECTION *selection);

___safe void destroyCDKScreen(
               CDKSCREEN *screen);

___safe void endCDK(void) ;

___safe void bindCDKObject (
               // was EObjectType cdkType,
               unsigned int cdkType,
               void *object,
	       chtype key,
               // was BINDFN function,
	       int (*)( unsigned int, void *, void *, chtype ),
               //void *function,
               void *data);

___safe void setCDKSelectionItems (
               CDKSELECTION *selection,
               char **list,
               int listSize);

___safe void setCDKSelectionTitle (
               CDKSELECTION *selection,
               char *title);

___safe void drawCDKSelection (
               CDKSELECTION *selection,
               boolean box);

// This doesn't seem to be of much general utility; it clears *all*
// bindings, not just the ones I would call "user defined".
___safe void cleanCDKObjectBindings (
               // was EObjectType cdkType,
               unsigned int cdkType,
               void *object);

___safe void unbindCDKObject (
               // was EObjectType cdkType,
               unsigned int cdkType,
               void *object,
               chtype key);

unsigned int CDKallocStrings(
               char ***list,
               char *item,
               unsigned int length,
               unsigned int used);

unsigned int CDKcountStrings (
               char **list);

void CDKfreeStrings (
               char **list);

___safe void setCDKSelectionPreProcess (
               CDKSELECTION *selection,
               // was PROCESSFN callback,
	       int (*)( unsigned int, void *, void *, unsigned int),
               void * data);

___safe int injectCDKSelection (
               CDKSELECTION *selection,
               chtype input);

___safe CDKLABEL *newCDKLabel (
               CDKSCREEN *cdkscreen,
               int xpos,
               int ypos,
               char **message,
               int messageLines,
               boolean box,
               boolean shadow);

___safe void drawCDKLabel (
               CDKLABEL *label,
               boolean box);

___safe void eraseCDKLabel (
		    CDKLABEL *label);

___safe void setCDKLabelMessage (
               CDKLABEL *label,
               char **message,
               int messageLines);

char waitCDKLabel (
		   CDKLABEL *label,
		   char key);

void writeChar (
               WINDOW *window,
               int xpos,
               int ypos,
               char *string,
               int align,
               int start,
               int end);

void writeCharAttrib (
               WINDOW *window,
               int xpos,
               int ypos,
               char *string,
               chtype attr,
               int align,
               int start,
               int end);

void eraseCDKScreen(CDKSCREEN *screen);

___safe void setCDKObjectWaiting(
			 CDKOBJS *obj,
			 // was WAITFN fn,
			 void (*)(void *, void*), 
			 void *data);

int getCDKSelectionChoice (
			   CDKSELECTION *selection,
			   int index);

void setCDKSelectionChoice (
			    CDKSELECTION *selection,
			    int index,
			    int choice);

int getCDKSelectionCurrent (
			    CDKSELECTION *selection);

void setCDKSelectionCurrent (
			     CDKSELECTION *selection,
			     int index);

char *getString (
		 CDKSCREEN *screen,
		 char *title,
		 char *label,
		 char *init);

void popupLabel (
		 CDKSCREEN *win,
		 char **mesg,
		 int count);

/*
* Entry widget bits
*/

char *activateCDKEntry (
			CDKENTRY *entry,
			chtype *actions);

void destroyCDKEntry (
		      CDKENTRY *entry);

void drawCDKEntry (
		   CDKENTRY *entry,
		   boolean box);

CDKENTRY *newCDKEntry (
		       CDKSCREEN *cdkscreen,
		       int xpos,
		       int ypos,
		       char *title,
		       char *label,
		       chtype fieldAttribute,
		       chtype fillerCharacter,
		       EDisplayType displayType,
		       int fieldWidth,
		       int minimumLength,
		       int maximumLength,
		       boolean box,
		       boolean shadow);

void setCDKEntryValue (
		       CDKENTRY *entry,
		       char *value);

/*
* Scrolling list widget
*/
___safe CDKSCROLL *newCDKScroll (
			 CDKSCREEN *cdkscreen,
			 int xpos,
			 int ypos,
			 int spos,
			 int height,
			 int width,
			 char *title,
			 char **itemList,
			 int items,
			 boolean numbers,
			 chtype highlight,
			 boolean box,
			 boolean shadow);

___safe int activateCDKScroll (
		       CDKSCROLL *scroll,
		       chtype * actions);

void destroyCDKScroll (
		       CDKSCROLL *scroll);

___safe void drawCDKScroll (
		    CDKSCROLL *scroll,
		    boolean box);

___safe void setCDKScrollPreProcess (
			     CDKSCROLL *scroll,
			     // was PROCESSFN callback,
			     int (*)( unsigned int, void *, void *, unsigned int),
			     void * data);

___safe int injectCDKScroll (
			     CDKSCROLL *scroll,
			     chtype input);
<#

; An auxillary function: Returns a list of all the index numbers
; in the selection widget that are selected.
(define (get-selection-choices-list widget)
  (define-external widget2 c-pointer widget)
  (let*
    ; Get the count of selection list items; saves us passing them
    ; in.
    ([count (foreign-value "((CDKSELECTION *)widget2)->listSize" unsigned-int)])
    ; Walk the list of values (i.e. a for loop :)
    (filter-map
      (lambda (num)
	(cond
	  ; If this num is true, return it
	  [(eq? (getCDKSelectionChoice selection-widget num) 1)
	   num]
	  [else #f]))
      (iota count))))

; Clear the current selection list
(define (clear-selection-choices-list widget)
  (define-external widget2 c-pointer widget)
  (let*
    ; Get the count of selection list items; saves us passing them
    ; in.
    ([count (foreign-value "((CDKSELECTION *)widget2)->listSize" unsigned-int)])
    ; Walk the list of values (i.e. a for loop :)
    (filter-map
      (lambda (num)
	(setCDKSelectionChoice widget num 0))
      (iota count))))

; My own little C function(s)

#>
char **make_strings(C_word lst)
{
int len, i;
C_word tmp;
   char **hlist;

/*
printf( "in make_strings.\n" );
printf( "in make_strings2: %d.\n",C_unfix(C_i_length(lst)) );
*/

   len = C_unfix(C_i_length(lst));
   hlist = (char**) malloc(sizeof(char*) * (len + 5));

   for(i = 0, tmp = lst; i < len; i++, tmp = C_u_i_cdr(tmp)) {
	 char *sstring;
	 char *cstring;
	 unsigned int slength=C_unfix(C_i_string_length(C_u_i_car(tmp)));


	 cstring = (char *)malloc( (slength + 5) * sizeof( char ));
	 strncpy( cstring, C_c_string(C_u_i_car(tmp)), slength );
	 cstring[slength] = 0;
	 hlist[i] = cstring;

	//fprintf( stderr, "\n\nslen: %u.\n", slength);
	//fprintf( stderr, "str: %d, %s.\n", i, hlist[i] );
   }
   hlist[i] = NULL;

   return hlist;
}

/*
NOT USING
void cdk_exit(void *obj)
{
    ((CDKOBJS *)obj)->earlyExit = vEARLY_EXIT;
    ((CDKOBJS *)obj)->exitType = 0;
}
*/
<#

#>!
char **make_strings(C_word lst);
//void cdk_exit(void *obj);
<#
