(declare (unit config))

(include "logger.sci")

; Write config info
(define (write-config)
  (logger "In write-config.\n")
  (let* ([output-port (open-output-file (conc config-dir "/clients/cluck.scm"))])
    (write 
      (map
	(lambda (val)
	  (logger "In write-config: val: " val ", " (global-ref val) nl)
	  (list val (global-ref val)))
	config-saves)
      output-port)))

; Read config info
(define (read-config)
  (logger "In read-config.\n")
  (cond
    [(file-exists? (conc config-dir "/clients/cluck.scm"))
     (let* ([input-port (open-input-file (conc config-dir "/clients/cluck.scm"))]
	    [configs-alist (read input-port)])
       (logger "In read-config: alist: " configs-alist nl)
       (for-each
	 (lambda (aval)
	   (logger "In read-config: aval: " (first aval) ", " (second aval))
	   (global-set! (first aval) (second aval)))
	 configs-alist))]
    ; Lack of config file will fix itself; lack of directory, not so
    ; much.
    [(not (directory? (conc config-dir "/clients/")))
     (fmt #t
"

You seem to not have a directory named " (conc config-dir "/clients/") "
which is where the config file for Cluck goes.  Since having a
config file reduces the load time by Quite A Bit, I'm going to have
to ask you to create this directory; typing:

    mkdir -p " (conc config-dir "/clients/") "

should do the trick.")
    (exit 1)]))
