;  XMMS2 - X Music Multiplexer System
 ;  Copyright (C) 2003-2006 XMMS2 Team
 ; 
 ;  This library is free software; you can redistribute it and/or
 ;  modify it under the terms of the GNU Lesser General Public
 ;  License as published by the Free Software Foundation; either
 ;  version 2.1 of the License, or (at your option) any later version.
 ;                   
 ;  This library is distributed in the hope that it will be useful,
 ;  but WITHOUT ANY WARRANTY; without even the implied warranty of
 ;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 ;  Lesser General Public License for more details.
 ;
 ;  This file is a part of the XMMS2 client tutorial #2
 ;  Here we will learn to retrieve results from a command

#>
#include <stdlib.h>

#include <xmmsclient/xmmsclient.h>
<#

#>!
xmmsc_connection_t *xmmsc_init (const char *clientname);
int xmmsc_connect (xmmsc_connection_t *, const char *);
xmmsc_result_t *xmmsc_playback_current_id (xmmsc_connection_t *c);
void xmmsc_result_wait (xmmsc_result_t *res);
int xmmsc_result_iserror (xmmsc_result_t *res);
int xmmsc_result_get_uint (xmmsc_result_t *res, uint32_t *r);
void xmmsc_unref (xmmsc_connection_t *c);
void xmmsc_result_unref (xmmsc_result_t *res);
<#

	;
	 ; The first part of this program is
	 ; commented in tut1.c See that one for
	 ; instructions
	 ;
(define conn (xmmsc_init "tut2"))

(xmmsc_connect conn "unix:///tmp/xmms-ipc-rlpowell")
	;
	 ; Now we send a command that will return
	 ; a result. Let's find out which entry
	 ; is currently playing. 
	 ;
	 ; Note that this program has be run while 
	 ; xmms2 is playing something, otherwise
	 ; xmmsc_playback_current_id will return 0.
	 ;
(define result (xmmsc_playback_current_id conn))

	;
	 ; We are still doing sync operations, wait for the
	 ; answer and block.
	 ;
(xmmsc_result_wait result)

	;
	 ; Also this time we need to check for errors.
	 ; Errors can occur on all commands, but not signals
	 ; and broadcasts. We will talk about these later.
	 ;
(display (conc "result is error: " (xmmsc_result_iserror result) "\n"))

	;
	 ; Let's retrieve the value from the result struct.
	 ; The caveat here is that you have to know what type
	 ; of value is returned in response to each command.
	 ;
	 ; In this case we know that xmmsc_playback_current_id
	 ; will return a UINT
	 ;
	 ; Know that all xmmsc_result_get calls can return FALSE
	 ; and that means that the value you are requesting is
	 ; not in the result struct.
	 ;
	 ; Values are stored in the pointer passed to result_get
	 ;
(define-external id unsigned-int32 7823412)
(display "before get_uint.\n")
(xmmsc_result_get_uint result (location id))
(display "after get_uint.\n")
(display (conc "uint: " id "\n"))

(display "after let-location.\n")

(xmmsc_result_unref result)

(xmmsc_unref conn)

